/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor;

import java.util.Set;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ListDialog;

import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.util.TaxonTreeNodeContentProvider;
import eu.etaxonomy.taxeditor.util.TaxonTreeNodeLabelProvider;

/**
 * @author k.luther
 * @since 28.08.2018
 *
 */
public class ChooseFromMultipleAcceptedTaxaDialog extends ListDialog{

        public static TaxonNode choose(Set<TaxonNode> taxonNodes){
            ChooseFromMultipleAcceptedTaxaDialog dialog = new ChooseFromMultipleAcceptedTaxaDialog(EditorUtil.getShell());
            dialog.setInput(taxonNodes);
            int result = dialog.open();

            if(result == IStatus.OK){
                TaxonNode selectedTaxonNode = (TaxonNode) dialog.getResult()[0];

                return selectedTaxonNode;

            }
            return null;
        }

        public ChooseFromMultipleAcceptedTaxaDialog(Shell parent) {
            super(parent);
            setTitle(Messages.ChooseFromMultipleAcceptedTaxaDialog_CHOOSE_ACCEPTED_TAXON);
            setMessage(Messages.ChooseFromMultipleAcceptedTaxaDialog_CHOOSE_ACCEPTED_TAXON_MESSAGE);
            setContentProvider(new TaxonTreeNodeContentProvider());
            setLabelProvider(new TaxonTreeNodeLabelProvider());
        }

//        private class ClassificationLabelProvider extends LabelProvider{
//            @Override
//            public String getText(Object element) {
//                return super.getText(((Classification) element).getTitleCache());
//            }
//        }

//        private class ClassificationContentProvider implements IStructuredContentProvider{
//
//            @Override
//            public Object[] getElements(Object inputElement) {
//                Set<TaxonNode> taxonNodes = (Set<TaxonNode>) inputElement;
//
//                    List<Classification> classifications = new ArrayList<Classification>();
//
//                    for(TaxonNode node : taxonNodes){
//                        classifications.add(node.getClassification());
//                    }
//
//                    return classifications.toArray();
//            }
//
//            @Override
//            public void dispose() {
//
//            }
//
//            @Override
//            public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
//
//            }
//        }
 //   }

}
