/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor;

import eu.etaxonomy.cdm.model.name.INonViralName;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;

/**
 * <p>OpenEditorConfiguration class.</p>
 *
 * @author n.hoffmann
 * @created Sep 27, 2010
 */
public class OpenEditorConfiguration {
	
	private TaxonNode parentNode;
	
	private INonViralName nonViralName;
	
	private boolean openInEditor;
	
	/**
	 * <p>Getter for the field <code>parentNode</code>.</p>
	 *
	 * @return the parent
	 */
	public TaxonNode getParentNode() {
		return parentNode;
	}

	/**
	 * <p>Setter for the field <code>parentNode</code>.</p>
	 *
	 * @param parent the parent to set
	 */
	public void setParentNode(TaxonNode parent) {
		this.parentNode = parent;
	}

	

	/**
	 * <p>isOpenInEditor</p>
	 *
	 * @return the openInEditor
	 */
	public boolean isOpenInEditor() {
		return openInEditor;
	}

	/**
	 * <p>Setter for the field <code>openInEditor</code>.</p>
	 *
	 * @param openInEditor the openInEditor to set
	 */
	public void setOpenInEditor(boolean openInEditor) {
		this.openInEditor = openInEditor;
	}

	/**
	 * <p>Getter for the field <code>nonViralName</code>.</p>
	 *
	 * @return the nonViralName
	 */
	public INonViralName getNonViralName() {
		return nonViralName;
	}

	/**
	 * <p>Setter for the field <code>nonViralName</code>.</p>
	 *
	 * @param nonViralName the nonViralName to set
	 */
	public void setNonViralName(INonViralName nonViralName) {
		this.nonViralName = nonViralName;
	}

}
