/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.descriptiveDataSet.character.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.UISynchronize;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.taxeditor.editor.descriptiveDataSet.character.CharacterEditor;
import eu.etaxonomy.taxeditor.featuretree.e4.handler.AddFeatureHandler;

/**
 * @author pplitzner
 * @since Jul 12, 2017
 *
 */
public class AddFeatureToCharacterTreeHandler extends AddFeatureHandler {

    @Execute
    @Override
    public void execute(@Named(IServiceConstants.ACTIVE_SHELL) Shell shell,
            @Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART)MPart thisPart, UISynchronize sync) {
        CharacterEditor editor = (CharacterEditor) thisPart.getObject();
        super.execute(shell, new StructuredSelection(editor.getCharacterTree()), thisPart, sync);
    }

    @Override
    @CanExecute
    public boolean canExecute(
            @Optional@Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART)MPart thisPart,
            MHandledMenuItem menuItem) {
        boolean canExecute = false;
        canExecute = thisPart.getObject() instanceof CharacterEditor
                && ((CharacterEditor) thisPart.getObject()).getCharacterTree()!=null
                && (selection==null || selection.isEmpty());
        menuItem.setVisible(canExecute);
        return canExecute;
    }
}
