
package eu.etaxonomy.taxeditor.editor.descriptiveDataSet.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.services.IServiceConstants;

import eu.etaxonomy.cdm.api.service.IDescriptiveDataSetService;
import eu.etaxonomy.cdm.model.description.DescriptiveDataSet;
import eu.etaxonomy.taxeditor.editor.descriptiveDataSet.DescriptiveDataSetNavigator;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class CreateDescriptiveDataSetHandler {

	@Execute
	public void execute(@Named(IServiceConstants.ACTIVE_PART)MPart activePart) {
	    DescriptiveDataSetNavigator navigator = (DescriptiveDataSetNavigator) activePart.getObject();
	    DescriptiveDataSet descriptiveDataSet = DescriptiveDataSet.NewInstance();
	    descriptiveDataSet.setLabel(Messages.CreateDescriptiveDataSetHandler_NEW_DESCRIPTIVE_DATA_SET);
	    CdmStore.getService(IDescriptiveDataSetService.class).merge(descriptiveDataSet, true);
	    navigator.getConversationHolder().commit();
	    navigator.addDescriptiveDataSet(descriptiveDataSet);
	}

}