
package eu.etaxonomy.taxeditor.editor.descriptiveDataSet.handler;

import java.util.Iterator;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.api.service.IDescriptiveDataSetService;
import eu.etaxonomy.cdm.model.description.DescriptiveDataSet;
import eu.etaxonomy.taxeditor.editor.descriptiveDataSet.DescriptiveDataSetNavigator;
import eu.etaxonomy.taxeditor.editor.internal.TaxeditorEditorPlugin;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class DeleteDescriptiveDataSetHandler {

	@Execute
	public void execute(@Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
	        @Named(IServiceConstants.ACTIVE_PART)MPart activePart) {
	    boolean confirm = MessagingUtils.confirmDialog(Messages.DeleteDescriptiveDataSetHandler_DELETE_TITLE, Messages.DeleteDescriptiveDataSetHandler_DELETE_MESSAGE);
	    Object object = activePart.getObject();
	    if(!selection.isEmpty() && confirm && object instanceof DescriptiveDataSetNavigator){
	        Iterator iterator = selection.iterator();
	        while(iterator.hasNext()){
	            Object next = iterator.next();
	            if(next instanceof DescriptiveDataSet){
	                    IDescriptiveDataSetService descriptiveDataSetService = CdmStore.getService(IDescriptiveDataSetService.class);
	                    descriptiveDataSetService.delete(((DescriptiveDataSet) next).getUuid());
	                    DescriptiveDataSetNavigator navigator = (DescriptiveDataSetNavigator) object;
	                    navigator.removeDescriptiveDataSet((DescriptiveDataSet) next);
	                    navigator.getConversationHolder().commit();
	                }
	                else{
	                    MessagingUtils.errorDialog(Messages.DeleteDescriptiveDataSetHandler_DELETE_FAILED_TITLE, DeleteDescriptiveDataSetHandler.class, Messages.DeleteDescriptiveDataSetHandler_DELETE_FAILED_MESSAGE, TaxeditorEditorPlugin.PLUGIN_ID, null, false);
	                    return;
	                }
	        }
	    }
	}

}