
package eu.etaxonomy.taxeditor.editor.descriptiveDataSet.handler;

import java.util.UUID;

import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IDescriptiveDataSetService;
import eu.etaxonomy.cdm.model.description.DescriptiveDataSet;
import eu.etaxonomy.taxeditor.editor.AppModelId;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.handler.defaultHandler.e4.DefaultOpenHandlerBaseE4;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class OpenDescriptiveDataSetEditorHandler extends DefaultOpenHandlerBaseE4<DescriptiveDataSet>{

    /**
     * {@inheritDoc}
     */
    @Override
    protected DescriptiveDataSet getEntity(UUID uuid) {
        return CdmStore.getService(IDescriptiveDataSetService.class).load(uuid);
    }

    @Override
    protected void open(DescriptiveDataSet entity, Shell shell, EPartService partService) {
        EditorUtil.openDescriptiveDataSetEditor(entity.getUuid(), modelService, partService, application);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected boolean canExecute(DescriptiveDataSet entity) {
        return true;
    }

    @Override
    protected String getPartId() {
        return AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_VIEW_DESCRIPTIVEDATASET_DESCRIPTIVEDATASETEDITOR;
    }

}