// $Id$
/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.categorical;

import java.util.List;

import org.eclipse.nebula.widgets.nattable.edit.editor.IComboBoxDataProvider;

import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.cdm.model.description.State;
import eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrix;

/**
 * @author pplitzner
 * @date 24.07.2018
 *
 */
public class CategoricalComboBoxDataProvider implements IComboBoxDataProvider {

    private CharacterMatrix matrix;
    private int maxVisibleItems;

    public CategoricalComboBoxDataProvider(CharacterMatrix matrix) {
        super();
        this.matrix = matrix;
    }

    @Override
    public List<?> getValues(int columnIndex, int rowIndex) {
        Feature feature = matrix.getIndexToCharacterMap().get(columnIndex);
        List<State> supportedStatesForCategoricalFeature = matrix.getSupportedStatesForCategoricalFeature(feature);
        maxVisibleItems = Math.max(3, Math.min(supportedStatesForCategoricalFeature.size()-1, 10));
        return supportedStatesForCategoricalFeature;
    }

    int getMaxVisibleItems(){
        return maxVisibleItems;
    }
}
