/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.quantitative;

import org.eclipse.nebula.widgets.nattable.data.convert.DisplayConverter;

import eu.etaxonomy.cdm.model.description.QuantitativeData;

/**
 * Converts QuantitativeData of one cell of the character matrix to a String.
 *
 * @author pplitzner
 * @since Dec 1, 2017
 *
 */
public class QuantitativeDataEditModeDisplayConverter extends DisplayConverter {

    @Override
    public Object canonicalToDisplayValue(Object canonicalValue) {
        if(canonicalValue instanceof QuantitativeData){
            return canonicalValue;
        }
        if(canonicalValue!=null){
            return canonicalValue.toString();
        }
        return null;
    }

    @Override
    public Object displayToCanonicalValue(Object displayValue) {
        return displayValue;
    }

}
