package eu.etaxonomy.taxeditor.editor.handler.defaultHandler;
import java.util.UUID;

import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.EPartService.PartState;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignation;
import eu.etaxonomy.taxeditor.editor.AppModelId;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateView;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateViewEditorInput;
import eu.etaxonomy.taxeditor.handler.defaultHandler.e4.DefaultOpenHandlerBaseE4;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.store.internal.TaxeditorStorePlugin;


public class DefaultOpenSpecimenEditorForTypeSpecimenHandler extends
		DefaultOpenHandlerBaseE4<SpecimenTypeDesignation> {

	@Override
	protected SpecimenTypeDesignation getEntity(UUID uuid) {
		return CdmStore.getCommonService().find(SpecimenTypeDesignation.class, uuid);
	}

	@Override
	protected void open(SpecimenTypeDesignation entity, Shell shell, EPartService partService) {
	    DerivateViewEditorInput input = new DerivateViewEditorInput(entity.getTypeSpecimen().getUuid());
	    MPart part = TaxeditorStorePlugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getService(EPartService.class).showPart(
	            AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_VIEW_DERIVATE_DERIVATEVIEW, PartState.ACTIVATE);
	    DerivateView derivateView = (DerivateView) part.getObject();
	    derivateView.init(input);
	}

    @Override
    protected boolean canExecute(SpecimenTypeDesignation entity) {
        return true;
    }

    @Override
    protected String getPartId() {
        return AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_VIEW_DERIVATE_DERIVATEVIEW;
    }

}
