package eu.etaxonomy.taxeditor.editor.handler.defaultHandler;
import java.util.UUID;

import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.ITaxonService;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.editor.AppModelId;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.handler.defaultHandler.e4.DefaultOpenHandlerBaseE4;
import eu.etaxonomy.taxeditor.store.CdmStore;


public class DefaultOpenTaxonEditorForTaxonBaseHandler extends DefaultOpenHandlerBaseE4<TaxonBase> {

    @Override
    protected TaxonBase getEntity(UUID uuid) {
        return CdmStore.getService(ITaxonService.class).load(uuid);
    }

    @Override
    protected void open(TaxonBase entity, Shell shell, EPartService partService) {
        EditorUtil.openTaxonBaseE4(entity.getUuid(), modelService, partService, application);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected boolean canExecute(TaxonBase entity) {
        return true;
    }

    @Override
    protected String getPartId() {
        return AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_NAME_E4_TAXONNAMEEDITORE4;
    }

}
