package eu.etaxonomy.taxeditor.editor.handler.defaultHandler;
import java.util.UUID;

import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.ITaxonNodeService;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.editor.AppModelId;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.handler.defaultHandler.e4.DefaultOpenHandlerBaseE4;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.store.CdmStore;


public class DefaultOpenTaxonEditorForTaxonNodeHandler extends DefaultOpenHandlerBaseE4<TaxonNode> {

    @Override
    protected TaxonNode getEntity(UUID uuid) {
        return CdmStore.getService(ITaxonNodeService.class).load(uuid);
    }

    @Override
    protected void open(TaxonNode entity, Shell shell, EPartService partService) {
        try {
            EditorUtil.openTaxonNodeE4(entity.getUuid(), modelService, partService, application);
        } catch (Exception e) {
            MessagingUtils.error(DefaultOpenTaxonEditorForTaxonNodeHandler.class, Messages.DefaultOpenTaxonEditorForTaxonNodeHandler_COULD_NOT_OPEN+entity.getTaxon(), e);
        }
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected boolean canExecute(TaxonNode entity) {
        return entity.getTaxon()!=null ;
    }

    @Override
    protected String getPartId() {
        return AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_NAME_E4_TAXONNAMEEDITORE4;
    }

}
