package eu.etaxonomy.taxeditor.editor.internal;

import org.apache.log4j.Logger;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import eu.etaxonomy.taxeditor.editor.UseObjectManager;
import eu.etaxonomy.taxeditor.editor.validation.ValidationContextListener;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * The activator class controls the plug-in life cycle
 *
 * @author n.hoffmann
 * @version $Id: $
 */
public class TaxeditorEditorPlugin extends AbstractUIPlugin {

	/** Constant <code>logger</code> */
	public static final Logger logger = Logger.getLogger(TaxeditorEditorPlugin.class);

	// The plug-in ID
	/** Constant <code>PLUGIN_ID="eu.etaxonomy.taxeditor.editor"</code> */
	public static final String PLUGIN_ID = "eu.etaxonomy.taxeditor.editor"; //$NON-NLS-1$

	// The shared instance
	private static TaxeditorEditorPlugin plugin;

	/**
	 * The constructor
	 */
	public TaxeditorEditorPlugin() {
	}

	/** {@inheritDoc} */
	@Override
    public void start(BundleContext context) throws Exception {
		super.start(context);

		UseObjectManager useManager = new UseObjectManager();
		CdmStore.getContextManager().addContextListener(useManager);

		ValidationContextListener vcl = new ValidationContextListener();
//		CdmStore.getContextManager().addContextListener(vcl);

		plugin = this;
		logger.trace("Plugin started: " + this.getBundle().getSymbolicName()); //$NON-NLS-1$
	}


	/** {@inheritDoc} */
	@Override
    public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
		logger.trace("Plugin stopped"); //$NON-NLS-1$
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static TaxeditorEditorPlugin getDefault() {
		return plugin;
	}
}
