/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.editor.key.polytomous;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

import eu.etaxonomy.cdm.hibernate.HHH_9751_Util;
import eu.etaxonomy.cdm.model.description.PolytomousKeyNode;

/**
 * @author n.hoffmann
 * @created Apr 4, 2011
 * @version 1.0
 */
public class PolytomousKeyListContentProvider implements
		IStructuredContentProvider {

	/*
	 * (non-Javadoc)
	 *
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	@Override
	public void dispose() {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface
	 * .viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java
	 * .lang.Object)
	 */
	@Override
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof PolytomousKeyEditorInput) {
			List<PolytomousKeyNode> result = new ArrayList<PolytomousKeyNode>();

			PolytomousKeyNode root = ((PolytomousKeyEditorInput) inputElement).getKey().getRoot();

			getChildrenBreadthFirst(result, root);
			return result.toArray();
		}

		return null;
	}

	private void getChildrenBreadthFirst(List<PolytomousKeyNode> result,
			PolytomousKeyNode node) {
	    if (node == null){
	        return;
	    }
		if (!node.getChildren().isEmpty()) {
			result.addAll(node.getChildren());
			HHH_9751_Util.removeAllNull(result);
			for (PolytomousKeyNode internalNode : node.getChildren()) {
				getChildrenBreadthFirst(result, internalNode);
			}
		}
	}
}
