/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.name.e4.container;

import org.eclipse.swt.graphics.Font;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.preference.Resources;

public class AcceptedNameContainerE4 extends AbstractGroupedContainerE4<Taxon> {

	public AcceptedNameContainerE4(AcceptedGroupE4 group, Taxon taxon) {
		super(group, taxon);
	}

	@Override
    public void initializeComposite(){
		setFont(getViewerFont());

		initTextViewer();
	}

	/** {@inheritDoc} */
	@Override
	protected Font getViewerFont() {
		return AbstractUtility.getFont(Resources.ACCEPTED_TAXON_FONT);
	}

	/** {@inheritDoc} */
	@Override
	protected void updateNonEditableInfo() {
		// not needed
	}


	@Override
	protected void updateIcon() {
		setIcon(ACCEPTED_ICON);
	}

	@Override
	protected void updateIndent() {
		setIndent(ACCEPTED_INDENT);
	}

}
