/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.name.e4.container;

import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.taxeditor.editor.name.container.IContainerConstants;
import eu.etaxonomy.taxeditor.editor.name.e4.TaxonNameEditorE4;

/**
 *
 * @author pplitzner
 * @date Aug 24, 2017
 *
 */
public class HomotypicalSynonymGroupE4 extends AbstractHomotypicalGroupContainerE4 {

	public HomotypicalSynonymGroupE4(TaxonNameEditorE4 editor, HomotypicalGroup group) {
		super(editor, group);
	}

	@Override
	protected void createContainers() {
		createSynonymContainer();
	}

	@Override
    protected void createSynonymContainer(){
		int i = 0;
		int indent = IContainerConstants.SYNONYM_INDENT;
		Image icon = IContainerConstants.HETEROTYPIC_SYNONYM_ICON;
		for(Synonym synonym : getSynonyms()){
			if(i > 0){
				indent = IContainerConstants.HOMOTYPIC_SYNONYM_IN_HETEROTYPIC_GROUP_INDENT;
				icon = IContainerConstants.HOMOTYPIC_SYNONYM_IN_HETEROTYPIC_GROUP_ICON;
			}
			SynonymContainerE4 container = new SynonymContainerE4(this, synonym, indent, icon);
			this.add(container);
			container.createContent();
			i++;
		}
	}

	@Override
	protected boolean redrawNeeded(HomotypicalGroup homotypicalGroup) {
		return super.redrawNeeded(homotypicalGroup);
	}
}
