/**
 *
 */
package eu.etaxonomy.taxeditor.editor.name.e4.dnd;

import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DragSourceAdapter;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.ui.forms.ManagedForm;

import eu.etaxonomy.cdm.model.common.ICdmBase;
import eu.etaxonomy.taxeditor.editor.CdmDataTransfer;
import eu.etaxonomy.taxeditor.editor.name.e4.container.AbstractGroupedContainerE4;
import eu.etaxonomy.taxeditor.editor.name.e4.container.ConceptContainerE4;

/**
 *
 * @author pplitzner
 * @date 04.09.2017
 *
 */
public class NameEditorDragListenerE4 extends DragSourceAdapter {

	private AbstractGroupedContainerE4 container;

	public NameEditorDragListenerE4(AbstractGroupedContainerE4 container){
		this.container = container;
	}

	/** {@inheritDoc} */
	@Override
    public void dragFinished(DragSourceEvent event) {
		if(!event.doit) {
            return;
        }
		if(event.detail == DND.DROP_MOVE){
			ManagedForm managedForm = container.getGroup().getEditor().getManagedForm();
			container.getGroup().remove(container);
			managedForm.reflow(true);
		}

	};

	/** {@inheritDoc} */
	@Override
	public void dragSetData(DragSourceEvent event) {
		ICdmBase[] cdmBaseObjects = new ICdmBase[]{container.getData()};
		if(CdmDataTransfer.getInstance().isSupportedType(event.dataType)){
		    event.data = cdmBaseObjects;
        }
	}

	/** {@inheritDoc} */
	@Override
	public void dragStart(DragSourceEvent event) {
		event.doit = (container.getData() != null) && !(container instanceof ConceptContainerE4);
	}
}
