/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.name.e4.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.di.UISynchronize;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
import eu.etaxonomy.taxeditor.editor.name.e4.TaxonNameEditorE4;
import eu.etaxonomy.taxeditor.editor.view.concept.operation.CreateConceptRelationOperation;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
import eu.etaxonomy.taxeditor.parser.ParseHandler;

/**
 * @author k.luther
 * @since 14.09.2018
 *
 */

public class CreateInvalidDesignationHandlerE4 {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART)MPart activePart,
            MHandledMenuItem menuItem,
            UISynchronize sync) {

        TaxonNameEditorE4 editor = (TaxonNameEditorE4) activePart.getObject();
        TaxonName conceptName = ParseHandler.createEmptyName();
        Taxon concept = Taxon.NewInstance(conceptName, null);
        TaxonRelationshipType type = TaxonRelationshipType.INVALID_DESIGNATION_FOR();
        AbstractPostOperation<?> operation;
        operation = new CreateConceptRelationOperation(menuItem.getLocalizedLabel(),
                editor.getUndoContext(), editor.getTaxon(), concept, type, editor);

        AbstractUtility.executeOperation(operation, sync);
    }

    @CanExecute
    public boolean canExecute(@Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            MHandledMenuItem menuItem){

        boolean canExecute = false;
        Object selectedElement = selection.getFirstElement();
     //   canExecute =NameEditorMenuPropertyTester.isNotInvalidDesignation(selectedElement);
        return true;
    }

}
