/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.name.e4.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.di.UISynchronize;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.taxeditor.editor.name.e4.TaxonNameEditorE4;
import eu.etaxonomy.taxeditor.editor.name.e4.container.AbstractGroupedContainerE4;

/**
 *
 * @author pplitzner
 * @since Aug 28, 2017
 *
 */
public class DeleteAllEmptyNamesHandlerE4 extends DeleteTaxonBaseHandlerE4 {

    @Override
    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART)MPart activePart,
            @Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_SHELL)Shell shell,
            MHandledMenuItem menuItem,
            UISynchronize sync) {

        editor = (TaxonNameEditorE4) activePart.getObject();

		for(AbstractGroupedContainerE4 containerWithEmptyName : editor.getEmptyContainers()){
		    editor.removeGroup(containerWithEmptyName.getGroup());
			doExecute(menuItem.getLocalizedLabel(), shell, editor, containerWithEmptyName.getData(), sync);
		}

	}

    @Override
    @CanExecute
    public boolean canExecute(
            @Named(IServiceConstants.ACTIVE_PART)MPart activePart,
            @Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            MHandledMenuItem menuItem){

        editor = (TaxonNameEditorE4) activePart.getObject();

        boolean canExecute = false;
        canExecute = editor.checkForEmptyNames();
        menuItem.setVisible(canExecute);
        return canExecute;
    }

}
