/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.checklist.e4;

import org.eclipse.jface.viewers.ColumnViewer;
import org.eclipse.jface.viewers.ColumnViewerEditorActivationStrategy;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;

/**
 * @author k.luther
 * @since 17.10.2018
 *
 */
public class DistributionEditorColumnViewerEditorActivationStrategy extends ColumnViewerEditorActivationStrategy {

    private KeyListener customkeyboardActivationListener;
    /**
     * @param viewer
     */
    public DistributionEditorColumnViewerEditorActivationStrategy(ColumnViewer viewer) {
        super(viewer);
        // TODO Auto-generated constructor stub
    }

    /**
     * Enable activation of cell editors by keyboard
     *
     * @param enable
     *            <code>true</code> to enable
     */
    @Override
    public void setEnableEditorActivationWithKeyboard(boolean enable) {
        super.setEnableEditorActivationWithKeyboard(enable);
        if (enable) {
            if (customkeyboardActivationListener == null) {
                customkeyboardActivationListener = new KeyListener() {

                    @Override
                    public void keyPressed(KeyEvent e) {

                    }

                    @Override
                    public void keyReleased(KeyEvent e) {
                        ViewerCell cell = getFocusCell();

//                        if (cell != null) {
//                        getViewer().getColumnViewerEditor().handleEditorActivationEvent(new ColumnViewerEditorActivationEvent(
//                                cell, e));
//                        }
                    }

                };
                getViewer().getControl().addKeyListener(customkeyboardActivationListener);
            }
        }
    }

    /**
     * @return the cell holding the current focus
     */
    private ViewerCell getFocusCell() {
        return getViewer().getColumnViewerEditor().getFocusCell();
    }

}
