/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.checklist.e4;

import org.eclipse.nebula.widgets.nattable.layer.LabelStack;
import org.eclipse.nebula.widgets.nattable.layer.cell.IConfigLabelAccumulator;

import eu.etaxonomy.cdm.api.service.dto.TaxonDistributionDTO;

/**
 * @author k.luther
 * @since 05.12.2018
 *
 */
public class DistributionEditorConfigLabelAccumulator  implements IConfigLabelAccumulator{

    public static final String STATUS = "STATUS";
    public static final String STATUS_EDITABLE = STATUS+"_EDITABLE";
    public static final String FILTER_EDITABLE = "FILTER_EDITABLE";


    private DistributionEditor editor;

    public DistributionEditorConfigLabelAccumulator(DistributionEditor editor) {
        super();
        this.editor = editor;
    }

    @Override
    public void accumulateConfigLabels(LabelStack configLabels, int columnPosition, int rowPosition) {
        boolean isEditable = true;

        Object rowObject = editor.getBodyDataProvider().getRowObject(rowPosition);
        TaxonDistributionDTO taxonRowWrapper = null;
        if(rowObject instanceof TaxonDistributionDTO){
            taxonRowWrapper = (TaxonDistributionDTO) rowObject;
        }

        if(columnPosition==0){
            configLabels.addLabel(DistributionEditor.TAXON_COLUMN);
            configLabels.addLabel(FILTER_EDITABLE);
        } else if(columnPosition==1 && editor.isShowRank()){
            configLabels.addLabel(DistributionEditor.RANK_COLUMN);
        } else{

            configLabels.addLabel(STATUS);
            if(isEditable){
                configLabels.addLabel(STATUS_EDITABLE);
            }



        }
    }
}
