/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.checklist.e4;

import java.util.Comparator;

import eu.etaxonomy.cdm.api.service.dto.TaxonDistributionDTO;

/**
 * @author k.luther
 * @since 28.11.2018
 *
 */
public class TaxonDistributionDtoComparator implements Comparator<TaxonDistributionDTO> {

    /**
     * {@inheritDoc}
     */
    @Override
    public int compare(TaxonDistributionDTO arg0, TaxonDistributionDTO arg1) {
        if (arg0 == arg1){
            return 0;
        }

        if (arg0.getTaxonUuid().equals(arg1.getTaxonUuid())){
            return 0;
        }

        String name1 = arg0.getNameCache();
        String name2 = arg1.getNameCache();
        Integer rankTax1 = arg0.getRankOrderIndex();
        Integer rankTax2 = arg1.getRankOrderIndex();

        if (rankTax1 == null && rankTax2 != null){
            return 1;
        }else if(rankTax2 == null && rankTax1 != null){
            return -1;
        }else if (rankTax1 == null && rankTax2 == null || rankTax1.equals(rankTax2)) {
            //same rank, order by name
            return name1.compareTo(name2);
         }else if (rankTax1 != null && rankTax1<rankTax2){
             return -1;
         }

        return 0;
    }

}
