package eu.etaxonomy.taxeditor.editor.view.checklist.e4.handler;

import java.util.UUID;

import javax.inject.Inject;

import org.eclipse.e4.core.services.log.Logger;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IClassificationService;
import eu.etaxonomy.cdm.api.service.ITaxonNodeService;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.taxon.ITaxonTreeNode;
import eu.etaxonomy.taxeditor.editor.AppModelId;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.handler.defaultHandler.e4.DefaultOpenHandlerBaseE4;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class OpenChecklistEditorHandlerE4 extends DefaultOpenHandlerBaseE4<ITaxonTreeNode> {
    @Inject
    private Logger logger;
    private static final String COULD_NOT_OPEN_DISTRIBUTION_EDITOR_THE_HIERARCHY_IS_CORRUPTED = Messages.OpenChecklistEditorHandler_COULD_NOT_OPEN_MESSAGE;
    private static final String COULD_NOT_OPEN_DISTRIBUTION_EDITOR = Messages.OpenChecklistEditorHandler_COULD_NOT_OPEN_TITLE;

    @Override
	protected ITaxonTreeNode getEntity(UUID uuid) {
		ITaxonTreeNode taxonTreeNode = CdmStore.getService(ITaxonNodeService.class).load(uuid);
		if(taxonTreeNode==null){
			taxonTreeNode = CdmStore.getService(IClassificationService.class).load(uuid);
		}
		return taxonTreeNode;
	}

	@Override
	protected void open(ITaxonTreeNode entity, Shell shell, EPartService partService) {

//		if (PreferencesUtil.getBooleanValue(EditorPreferencePredicate.DistributionEditorActivated.getKey())) {
//			if (StringUtils.isBlank(PreferencesUtil.getStringValue(PreferencePredicate.AvailableDistributionAreaVocabularies.getKey()) )){
//
//				MessagingUtils.informationDialog(Messages.OpenChecklistEditorHandler_NO_AREAS, Messages.OpenChecklistEditorHandler_CHOOSE_AREA
//						+ Messages.OpenChecklistEditorHandler_GOTO_PREFERENCES);
//				return;
//			}
//			if (entity instanceof Classification) {
//				ChecklistEditorInput input = new ChecklistEditorInput(((Classification) entity));
//				try {
//					openChecklistEditor(input, partService);
//				} catch (NullPointerException npe) {
//					MessagingUtils.messageDialog(COULD_NOT_OPEN_DISTRIBUTION_EDITOR, OpenChecklistEditorHandlerE4.class,
//							COULD_NOT_OPEN_DISTRIBUTION_EDITOR_THE_HIERARCHY_IS_CORRUPTED, npe);
//				}
//			} else if (entity instanceof TaxonNode) {
//				ChecklistEditorInput input = new ChecklistEditorInput((TaxonNode) entity);
//				try {
//					openChecklistEditor(input, partService);
//				} catch (NullPointerException npe) {
//					MessagingUtils.messageDialog(COULD_NOT_OPEN_DISTRIBUTION_EDITOR, OpenChecklistEditorHandlerE4.class,
//							COULD_NOT_OPEN_DISTRIBUTION_EDITOR_THE_HIERARCHY_IS_CORRUPTED, npe);
//				}
//			}
//		}

	    EditorUtil.openDistributionEditor(entity.getUuid(), modelService, partService, application);
	}

//	private void openChecklistEditor(ChecklistEditorInput input, EPartService partService) {
//		MPart part = partService.createPart(AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_VIEW_CHECKLIST_E4_CHECKLISTEDITORE4);
//		MPartStack editorAreaPartStack = WorkbenchUtility.getEditorAreaPartStack(application, modelService);
//		if(editorAreaPartStack!=null){
//		    editorAreaPartStack.getChildren().add(part);
//		}
//		part = partService.showPart(part, PartState.ACTIVATE);
//		ChecklistEditorE4 checklistEditor = (ChecklistEditorE4) part.getObject();
//		if (checklistEditor != null){
//			checklistEditor.init(input);
//		}else{
//			logger.debug("Editor is null");
//		}
//	}

    /**
     * {@inheritDoc}
     */
    @Override
    protected boolean canExecute(ITaxonTreeNode entity) {
        return entity!=null && PreferencesUtil.getBooleanValue(PreferencePredicate.DistributionEditorActivated.getKey());
    }

    @Override
    protected String getPartId() {
        return AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_VIEW_CHECKLIST_E4_DISTRIBUTIONEDITORPART;
    }
}
