/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.checklist.listener;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Text;

import eu.etaxonomy.taxeditor.editor.view.checklist.filter.ChecklistEditorFilter;

/**
 * @author alex
 * @date 27.06.2014
 *
 */
public class ChecklistModifyListener implements ModifyListener {

    private final Text searchText;
    private final Viewer editor;
    private final ChecklistEditorFilter filter;

    /**
     *
     */
    public ChecklistModifyListener(Viewer editor, ChecklistEditorFilter filter, Text searchText) {
        this.editor = editor;
        this.filter = filter;
        this.searchText = searchText;
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
     */
    @Override
    public void modifyText(ModifyEvent e) {
        filter.setSearchText(searchText.getText());

    }

}
