/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.derivate;

import org.eclipse.jface.viewers.ISelection;

/**
 * Wrapper for {@link ISelection} which additionally holds a
 * reference to the {@link DerivateView}
 * @author pplitzner
 * @date 14.05.2014
 *
 */
public class DerivateViewSelection implements ISelection {

    private final ISelection selection;
    private final DerivateView derivateView;

    /**
     * @param selection
     * @param derivateView
     */
    public DerivateViewSelection(ISelection selection, DerivateView derivateView) {
        super();
        this.selection = selection;
        this.derivateView = derivateView;
    }

    /**
     * @return the selection
     */
    public ISelection getSelection() {
        return selection;
    }

    /**
     * @return the derivateView
     */
    public DerivateView getDerivateView() {
        return derivateView;
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.viewers.ISelection#isEmpty()
     */
    @Override
    public boolean isEmpty() {
        return selection.isEmpty();
    }

}
