
package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import eu.etaxonomy.cdm.model.molecular.DnaSample;
import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;

public class AddDnaSampleHandler extends AbstractAddDerivativeHandler{

    @Override
    protected boolean isAllowed(Object derivative) {
        if(derivative instanceof FieldUnit || (derivative instanceof DerivedUnit
                && ((DerivedUnit) derivative).getRecordBasis().equals(SpecimenOrObservationType.PreservedSpecimen))
                || (derivative instanceof DnaSample && ((DnaSample)derivative).getRecordBasis()==SpecimenOrObservationType.TissueSample)){
            return true;
        }
        return false;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivedUnit createDerivative() {
        DnaSample dnaSample = DnaSample.NewInstance();
        dnaSample.setRecordBasis(SpecimenOrObservationType.DnaSample);
        return dnaSample;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivationEventType getDerivationeType() {
        return DerivationEventType.DNA_EXTRACTION();
    }

}