
package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import eu.etaxonomy.cdm.model.media.Media;
import eu.etaxonomy.cdm.model.molecular.DnaSample;
import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
import eu.etaxonomy.cdm.model.occurrence.MediaSpecimen;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.ui.dialog.selection.MediaSelectionDialog;

public class AddExistingMediaHandler extends AbstractAddDerivativeHandler{

    @Override
    protected boolean isAllowed(Object derivative) {
        if(derivative instanceof FieldUnit
                || (derivative instanceof DerivedUnit && ((DerivedUnit) derivative).getRecordBasis().equals(SpecimenOrObservationType.PreservedSpecimen))
                || (derivative instanceof DnaSample && ((DnaSample)derivative).getRecordBasis()==SpecimenOrObservationType.TissueSample)
                || (derivative instanceof DnaSample && ((DnaSample)derivative).getRecordBasis()==SpecimenOrObservationType.DnaSample)){
            return true;
        }
        return false;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivedUnit createDerivative() {
        MediaSpecimen mediaSpecimen = null;
        //select media
        Media media = MediaSelectionDialog.select(AbstractUtility.getShell(), //null,
                null);
        if(media!=null){
            //create MediaSpecimen
            mediaSpecimen = MediaSpecimen.NewInstance(SpecimenOrObservationType.StillImage);
            mediaSpecimen.setMediaSpecimen(media);
        }
        return mediaSpecimen;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivationEventType getDerivationeType() {
        return DerivationEventType.ACCESSIONING();
    }

}