package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import java.util.UUID;

import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IOccurrenceService;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
import eu.etaxonomy.taxeditor.editor.AppModelId;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateViewEditorInput;
import eu.etaxonomy.taxeditor.handler.defaultHandler.e4.DefaultOpenHandlerBaseE4;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class OpenDerivativeEditorForSpecimenOrOBservationBase extends DefaultOpenHandlerBaseE4<SpecimenOrObservationBase<?>>{

    protected static final String OPEN_DERIVATIVE_EDITOR_FOR_TAXON_NODE_COULD_NOT_OPEN = Messages.OpenDerivativeEditorForTaxonNode_COULD_NOT_OPEN;

    /**
     * {@inheritDoc}
     */
    @Override
    protected SpecimenOrObservationBase<?> getEntity(UUID uuid) {
        return CdmStore.getService(IOccurrenceService.class).load(uuid);
    }

    @Override
    protected void open(SpecimenOrObservationBase<?> entity, Shell shell, EPartService partService) {
        DerivateViewEditorInput input = new DerivateViewEditorInput(entity.getUuid());
        EditorUtil.openSpecimenEditor(input, modelService, partService, application);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected boolean canExecute(SpecimenOrObservationBase<?> entity) {
        //FIXME E4 when bulk editor is migrated then move the handler scope to the bulk editor part descriptor
        //in the model fragment
        return true;
    }

    @Override
    protected String getPartId() {
        return AppModelId.PARTDESCRIPTOR_EU_ETAXONOMY_TAXEDITOR_EDITOR_VIEW_DERIVATE_DERIVATEVIEW;
    }

}
