package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.util.LocalSelectionTransfer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeNode;

import eu.etaxonomy.cdm.model.molecular.SingleRead;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateView;

public class SingleReadCopyToClipboardHandler {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART) MPart part, @Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection){
        DerivateView derivateView = (DerivateView)part.getObject();
        LocalSelectionTransfer.getTransfer().setSelection(selection);
        derivateView.updateLabelCache();
        derivateView.refreshTree();
    }

    @CanExecute
    public boolean canExecute(@Optional @Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection,
            MHandledMenuItem menuItem){
        boolean canExecute = false;
        canExecute = selection!=null
                && selection.size()==1
                && selection.getFirstElement() instanceof TreeNode
                && ((TreeNode) selection.getFirstElement()).getValue() instanceof SingleRead;
        menuItem.setVisible(canExecute);
        return canExecute;
    }
}
