/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.view.descriptive;

import java.util.UUID;

import eu.etaxonomy.cdm.api.service.IDescriptionService;
import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
import eu.etaxonomy.taxeditor.model.CdmObjectTransfer;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Feb 8, 2011
 * @version 1.0
 */
public class DescriptionElementTransfer extends CdmObjectTransfer<DescriptionElementBase> {

	private static DescriptionElementTransfer instance = new DescriptionElementTransfer();
	private static final String TYPE_NAME = "descriptionElement-transfer-format"; //$NON-NLS-1$
	private static final int TYPEID = registerType(TYPE_NAME);
	
	public static synchronized DescriptionElementTransfer getInstance(){
		return instance;
	}
	
	private DescriptionElementTransfer(){}
	
	/* (non-Javadoc)
	 * @see org.eclipse.swt.dnd.Transfer#getTypeIds()
	 */
	@Override
	protected int[] getTypeIds() {
		return new int[] { TYPEID };
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.dnd.Transfer#getTypeNames()
	 */
	@Override
	protected String[] getTypeNames() {
		return new String[] { TYPE_NAME };
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.model.CdmObjectTransfer#loadElement(java.util.UUID)
	 */
	@Override
	public DescriptionElementBase loadElement(UUID uuid) {
		return CdmStore.getService(IDescriptionService.class).loadDescriptionElement(uuid, null);
	}
}
