/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.descriptive;

import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.DelegatingStyledCellLabelProvider.IStyledLabelProvider;
import org.eclipse.jface.viewers.StyledString;

import eu.etaxonomy.taxeditor.model.DescriptionHelper;

/**
 * @author p.ciardelli
 * @version $Id: $
 */
public class DescriptiveLabelProvider extends ColumnLabelProvider implements IStyledLabelProvider  {

    private static final String TRUNCATE_SIGN = "..."; //$NON-NLS-1$
    private static final int MAX_LENGTH = 150;

	@Override
    public String getText(Object element) {
		String text = DescriptionHelper.getLabel(element);
		text = text.replaceAll("[\\r\\n]", " "); //$NON-NLS-1$ //$NON-NLS-2$
		if(text.length()>MAX_LENGTH){
		    text = text.substring(0, MAX_LENGTH)+TRUNCATE_SIGN;
		}
        return text;
	}

	@Override
    public StyledString getStyledText(Object element) {
		return new StyledString(getText(element), StyledString.QUALIFIER_STYLER);
	}
}
