/**
* Copyright (C) 2013 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.descriptive.operation;

import org.eclipse.core.commands.operations.IUndoContext;

import eu.etaxonomy.cdm.model.common.IdentifiableSource;
import eu.etaxonomy.cdm.model.description.TaxonDescription;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.operation.AbstractDescriptionPostOperation;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;

/**
 * @author pplitzner
 * @date 04.12.2013
 *
 */
public class CreateTaxonDescriptionOperation extends AbstractDescriptionPostOperation<Taxon, TaxonDescription> {

    public CreateTaxonDescriptionOperation(String label, IUndoContext undoContext, Taxon describable,
            IdentifiableSource source, IPostOperationEnabled postOperationEnabled) {
        super(label, undoContext, describable, source, postOperationEnabled, false);
    }

    public CreateTaxonDescriptionOperation(String label, IUndoContext undoContext, Taxon describable,
            IdentifiableSource source, IPostOperationEnabled postOperationEnabled, boolean isImageGallery) {
        super(label, undoContext, describable, source, postOperationEnabled, isImageGallery);
    }

    @Override
    protected void initDescription(){
        description = TaxonDescription.NewInstance(element);
    }
}
