/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.view.descriptive.operation;

import org.eclipse.core.commands.operations.IUndoContext;

import eu.etaxonomy.cdm.model.common.IdentifiableSource;
import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.taxeditor.operation.AbstractDescriptionPostOperation;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;

/**
 * @author k.luther
 * @since 25 Jan 2019
 *
 */
public class CreateTaxonNameDescriptionOperation extends AbstractDescriptionPostOperation<TaxonName, TaxonNameDescription> {

    public CreateTaxonNameDescriptionOperation(String label, IUndoContext undoContext, TaxonName describable, IPostOperationEnabled postOperationEnabled) {
        super(label, undoContext, describable, null, postOperationEnabled);
    }

    public CreateTaxonNameDescriptionOperation(String label, IUndoContext undoContext, TaxonName describable,
            IdentifiableSource source, IPostOperationEnabled postOperationEnabled) {
        super(label, undoContext, describable, source, postOperationEnabled, false);
    }


    /**
     * {@inheritDoc}
     */
    @Override
    protected void initDescription() {
        description = TaxonNameDescription.NewInstance(element);

    }

}
