package eu.etaxonomy.taxeditor.editor.view.media.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.UISynchronize;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.model.application.ui.menu.MMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.model.description.DescriptionBase;
import eu.etaxonomy.cdm.model.media.Media;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.view.media.e4.MediaViewPartE4;
import eu.etaxonomy.taxeditor.editor.view.media.operation.AddExistingMediaToImageGalleryOperation;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
import eu.etaxonomy.taxeditor.ui.dialog.selection.MediaSelectionDialog;

public class AddExistingMediaHandler  {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART) MPart activePart,
            @Optional@Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection, MMenuItem menuItem,
            UISynchronize sync) {

        MediaViewPartE4 mediaView = (MediaViewPartE4) activePart.getObject();

        AbstractPostOperation operation = null;
        //select media
        Media media = MediaSelectionDialog.select(AbstractUtility.getShell(),// null,
                null);
        if(media!=null){
            // TODO use undo context specific to editor
            operation = new AddExistingMediaToImageGalleryOperation(media, menuItem.getLocalizedLabel(),
                    EditorUtil.getUndoContext(), (DescriptionBase<?>) selection.getFirstElement(), mediaView);
            AbstractUtility.executeOperation(operation, sync);
        }
    }

    @CanExecute
    private boolean canExecute(MHandledMenuItem menuItem,
            @Optional@Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection){
        boolean canExecute = false;
        canExecute = selection.size()==1 && selection.getFirstElement() instanceof DescriptionBase;
        menuItem.setVisible(canExecute);
        return canExecute;
    }

}
