package eu.etaxonomy.taxeditor.editor.view.validation;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.views.markers.MarkerField;
import org.eclipse.ui.views.markers.MarkerItem;

import eu.etaxonomy.taxeditor.editor.validation.MarkerManager;

public class InvalidValueMarkerField extends MarkerField {

	@Override
	public String getValue(MarkerItem item)
	{
		try {
			Object value = item.getMarker().getAttribute(MarkerManager.ATTRIB_INVALID_VALUE);
			return value == null ? "" : value.toString(); //$NON-NLS-1$
		}
		catch (CoreException e) {
			throw new RuntimeException("Error while retrieving value for " + MarkerManager.ATTRIB_INVALID_VALUE); //$NON-NLS-1$
		}
	}
}
